#  FriendlyAlbum - Photo Album for Plone
#  Copyright (c) 2006 IngeniWeb - Badredine Ladjemi <badredine.ladjemi@ingeniweb.com>
#  $Id: Install.py,v 1.2 2006/05/16 16:31:56 bladjemi Exp $
# 
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#  
"""
Installer for FriendlyAlbum

"""
from StringIO import StringIO

from Products.Archetypes.public import listTypes
from Products.Archetypes.Extensions.utils import installTypes, install_subskin
from Products.CMFCore.utils import getToolByName
from OFS.ObjectManager import BadRequestException

# Product specific resources
from Products.FriendlyAlbum import config

def install_css(portal, out):
    """
    install the css
    """
    portal_css = getToolByName(portal, 'portal_css')

    #portal_css.manage_addStylesheet(id='friendlyalbum.css',
    #				    expression="python:here.portal_type == 'FriendlyAlbum'",
    #				    media='all',
    #				    title='Friendly Album',
    #				    enabled=True,
    #				    cookable=True)
	
    print >>out, "CSS added"
    return out

def install_factory(portal, out, product_types=('FriendlyAlbum', 'FriendlyImage')):
    """
    install types to portal_factory
    """
    # Enable portal_factory
    
    factory = getToolByName(portal, 'portal_factory')
    factory_types = factory.getFactoryTypes()
    
    factory_types.update(dict([(type_name, None) for type_name in product_types]))
    new_types = factory_types.keys()
    
    factory.manage_setPortalFactoryTypes(listOfTypeIds=new_types)
    
    print >>out, "portal_factory: %s added" % (', '.join(product_types))
    return out

def install_js(portal, out):
    portal_javascripts = getToolByName(portal, 'portal_javascripts')

    for name in config.JAVASCRIPTS:
	portal_javascripts.registerScript(id=name,
					  enabled=True,
					  cookable=True)
	print >>out, "portal_javascripts: %s registered successfully" % name
    return out
    
def install(self):
   out = StringIO()
   
   # Install skin
   install_subskin(self, out, config.GLOBALS)
   install_js(self, out)
   install_css(self, out)
   product_types = listTypes(config.PROJECTNAME)
   install_factory(self, out)
   installTypes(self, out, product_types, config.PROJECTNAME)
   
   return out
